#include <iostream>
#include <vector>
#include <set>
#include <limits>
#include <tuple>
#include <algorithm>

using namespace std;

using edge = pair<int, int>; // (sused, duzina)

int dijkstra(int u, int v, vector< vector<edge> >& graf) {
	int n = graf.size();

	vector<int> udaljenost(n, numeric_limits<int>::max());
	set< pair<int, int> > pq;

	pq.insert({udaljenost[u] = 0, u});

	while(!pq.empty()) {
		int v = pq.begin()->second;
		pq.erase(pq.begin());

		for(auto e : graf[v]) {
			int w, duzina; tie(w, duzina) = e; // (sused, duzina)
			if(udaljenost[v] + duzina < udaljenost[w]) {
				pq.erase({udaljenost[w], w});
				udaljenost[w] = udaljenost[v] + duzina;
				pq.insert({udaljenost[w], w});
			}
		}
	}

	return udaljenost[v];
}

int main() {
	int n, m;
	cin >> n >> m;

	vector< vector<edge> > graf(n);
	for(int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		graf[u].push_back({v, w});
	}

	int x, y, z;
	cin >> x >> y >> z;

	int duzina1 = dijkstra(x, y, graf);
	int duzina2 = dijkstra(y, z, graf);
	cout << duzina1 + duzina2 << '\n';

	return 0;
}
