#include <iostream>
#include <vector>
#include <limits>

using namespace std;

vector<int> bellman_ford(int u, vector< vector< pair<int, int> > >& graf) {
	int n = graf.size();

	vector<int> udaljenost(n, numeric_limits<int>::max());
	udaljenost[u] = 0;

	for(int i = 0; i < n - 1; i++)
		for(int v = 0; v < n; v++)
			for(auto e : graf[v])
				udaljenost[e.first] = min(udaljenost[e.first], udaljenost[v] + e.second);

	return udaljenost;
}

int main() {
	int n, m;
	cin >> n >> m;

	vector< vector< pair<int, int> > > graf(n);
	for(int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		graf[u].push_back({v, w});
	}

	vector<int> d = bellman_ford(0, graf);
	for(int x : d)
		cout << x << ' ';
	cout << '\n';
	return 0;
}
