#include <iostream>
#include <vector>
#include <limits>

using namespace std;

using edge = pair<int, int>;

vector< vector<int> > floyd_warshall(vector< vector<edge> >& graf) {
	int n = graf.size();
	vector< vector<int> > d(n, vector<int>(n, numeric_limits<int>::max()));

	for(int u = 0; u < n; u++) {
		d[u][u] = 0;
		for(auto e : graf[u])
			d[u][e.first] = e.second;
	}

	for(int k = 0; k < n; k++)
		for(int i = 0; i < n; i++)
			for(int j = 0; j < n; j++)
				d[i][j] = min(d[i][j], d[i][k] + d[k][j]);

	return d;
}

int main() {
	int n, m;
	cin >> n >> m;

	vector< vector<edge> > graf(n);
	for(int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		graf[u].push_back({v, w});
		graf[v].push_back({u, w});
	}

	vector< vector<int> > udaljenosti = floyd_warshall(graf);

	for(int i = 0; i < n; i++) {
		for(int j = 0; j < n; j++)
			cout << udaljenosti[i][j] << ' ';
		cout << '\n';
	}

	return 0;
}
