#include <iostream>
#include <vector>
#include <set>
#include <limits>
#include <tuple>
#include <algorithm>

using namespace std;

using edge = pair<int, int>;

void dijkstra(int u, vector<int>& _p, vector< vector<edge> >& graf) {
	int n = graf.size();

	vector< pair<int, int> > d(n, {numeric_limits<int>::max(), 0});
	vector<int> p(n, -1);
	set< pair< pair<int, int>, int> > pq;
	
	pq.insert({d[u] = {0, 0}, u});
	while(!pq.empty()) {
		int v = pq.begin()->second;
		pq.erase(pq.begin());

		for(auto e : graf[v]) {
			int w, ew; tie(w, ew) = e;
			pair<int, int> nov_put = {d[v].first + ew, d[v].second + 1};
			if(nov_put < d[w]) {
				pq.erase({d[w], w});	
				d[w] = nov_put;
				p[w] = v;
				pq.insert({d[w], w});
			}
		}
	}

	_p = p;
}

vector<int> put(int v, vector<int>& prethodnik) {
	vector<int> p;
	while(v != -1) {
		p.push_back(v);
		v = prethodnik[v];
	}
	reverse(p.begin(), p.end());
	return p;
}

int main() {
	int n, m;
	cin >> n >> m;

	vector< vector<edge> > graf(n);
	for(int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		graf[u].push_back({v, w});
	}

	int u, v;
	cin >> u >> v;

	vector<int> p;
	dijkstra(u, p, graf);

	vector<int> put_u_v = put(v, p);
	for(int w : put_u_v)
		cout << w << ' ';
	cout << '\n';

	return 0;
}
