#include <iostream>
#include <vector>
#include <set>
#include <limits>
#include <tuple>
#include <algorithm>

using namespace std;

using edge = pair<int, int>; // (sused, duzina)

void dijkstra(vector<int>& stanice, vector<int>& _udaljenost, vector< vector<edge> >& graf) {
	int n = graf.size();

	vector<int> udaljenost(n, numeric_limits<int>::max());
	set< pair<int, int> > pq;

	for(int u : stanice)
		pq.insert({udaljenost[u] = 0, u});

	while(!pq.empty()) {
		int v = pq.begin()->second;
		pq.erase(pq.begin());

		for(auto e : graf[v]) {
			int w, duzina; tie(w, duzina) = e; // (sused, duzina)
			if(udaljenost[v] + duzina < udaljenost[w]) {
				pq.erase({udaljenost[w], w});
				udaljenost[w] = udaljenost[v] + duzina;
				pq.insert({udaljenost[w], w});
			}
		}
	}

	_udaljenost = udaljenost;
}

int main() {
	int n, m, s;
	cin >> n >> m;

	vector< vector<edge> > graf(n);
	for(int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		graf[u].push_back({v, w});
		graf[v].push_back({u, w});
	}

	cin >> s;
	vector<int> stanice(s);
	for(int i = 0; i < s; i++)
		cin >> stanice[i];

	vector<int> d;
	dijkstra(stanice, d, graf);

	for(int i = 0; i < n; i++)
		cout << i << ": " << d[i] << '\n';

	return 0;
}
